#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/un.h>
#include <pthread.h>

#include <fcntl.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/poll.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

#include <openssl/sha.h>
//#include "support/sha1.h"
#include "helper.h"
#include "crypto.h"
#include "cccam.h"




//////////////////////// CCCAM2 -----------------------------------------------------------

void* proxy_function(void* foo_ptr){
    static_cast<cCardClientCCcam2*>(foo_ptr)->Action(); }

cCardClientCCcam2::cCardClientCCcam2(char *server_url, unsigned int timeout,int hop)
{
  shareid1=0; pendingDCW=maxecmcount=0; newcw=login=false;
  cmd05mode=CMD05_MODE_UNKNOWN; cmd05off=0;
  ready=false; network_timeout=timeout; 
  shrcnt=0;
  memset(versstr,0,sizeof(versstr));
  memset(buildstr,0,sizeof(buildstr));
  memset(username,0,sizeof(username));
  memset(password,0,sizeof(password));
  memset(hostname,0,sizeof(hostname));
  Hop=hop;

 for (int i=0;i<500;i++)
    { ccshare[i].deleted=true; ccshare[i].status=false; }
  
  for(int i=0; i<sizeof(nodeid); i++) nodeid[i]=rand();
  wantEmus=true;
  sscanf(server_url, "C: %s %d %s %s %s %s",hostname, &port, username, password, versstr, buildstr);
// 578 	char *version[] = { "2.0.11", "2.1.1", "2.1.2", "2.1.3", "2.1.4", "2.2.0", "2.2.1", "2.3.0", "" };
// 579 	char *build[] = {   "2892",   "2971",  "3094",  "3165",  "3191",  "3290",  "3316",  "3367", "" };
  if (!strlen(versstr)) strcpy(versstr,"2.0.11\0");
  if (!strlen(buildstr)) strcpy(buildstr,"2892\0");
 
  printf ("[CCcam] User:%s  Pass:%s  login to : %s\n",username,password,hostname);

	struct hostent *host_address;
	struct sockaddr_in socket_address;
	
	host_address = gethostbyname(hostname);
	if(!host_address)
	{
		printf("[CCcam] Could not resolve hostname.\n");
		return;
	}
	
	if((fd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
	{
		printf("[CCcam] Could not get socket descriptor.\n");
		return;
	}
	
    socket_address.sin_family = AF_INET;
    socket_address.sin_port = htons(port);
    socket_address.sin_addr.s_addr = ((struct in_addr *) host_address->h_addr)->s_addr;
	
	if( connect(fd, (struct sockaddr *)(&socket_address), sizeof(struct sockaddr)) < 0 )
	{
		printf("[CCcam] Failed to connect to remote server.\n");
		return;
	}
	
	printf("[CCcam] Successfully connected to server. Starting Authentication\n");
	
	if (Login()) 
		{
		if  (ready)  printf("[CCcam] Succesfull server login completed.\n");
		pthread_mutex_init(&mtxshare, NULL);
		pthread_mutex_init(&mtxcw, NULL);
		pthread_mutex_init(&mtxsend, NULL);
		pthread_mutex_init(&mtxrecv, NULL);
		if (pthread_create(&myaction, NULL, proxy_function, this) != 0) { printf("Thread Failed\n"); 	exit (0); }
		} else printf("Login Failed\n");

}

bool cCardClientCCcam2::Login(void)
{

  unsigned char buffer[512];
  int len;
  if((len=RecvMsg(buffer,16,-1))<0) {
    printf("[CCcam] no welcome from server\n");
    return false;
    }

  if(!cCCcamCrypt::CheckConnectChecksum(buffer,len)) {
    printf("[CCcam] bad welcome from server\n");
    return false;
    }
  //printf("Welcome Ok.\n");
  cCCcamCrypt::Xor(buffer,len);
  unsigned char buff2[64];
  //SHA1_CTX ctx;
  //sha1_init( &ctx );
  //sha1_update( &ctx, buffer, len );
  //sha1_final( &ctx, buff2 );
  SHA1(buffer,len,buff2);
  decr.Init(buff2,20);
  decr.Decrypt(buffer,buffer,16);
  encr.Init(buffer,16);
  encr.Encrypt(buff2,buff2,20);

  //LDUMP(L_CC_CCCAM2DT,buff2,20,"welcome response:");
  if(!CryptSend(buff2,20)) {
    printf("[CCcam] failed to send welcome response\n");
    return false;
    }
  //printf("Welcome Response Ok.\n");
  memset(buffer,0,20);
  strcpy((char *)buffer,username);
  //LDUMP(L_CC_CCCAM2DT,buffer,20,"send username:");
  if(!CryptSend(buffer,20)) {
    printf("[CCcam] failed to send username\n");
    return false;
    }
  //printf("Username Sent Ok.\n");

  encr.Encrypt((unsigned char *)password,buffer,strlen(password));
  if(!CryptSend((unsigned char *)cccamstr,6)) {
    printf("[CCcam] failed to send password hash\n");
    return false;
    }
  //printf("Pass Hash Sent Ok.\n");

  if((len=CryptRecv(buffer,20))<0) {
    printf("[CCcam] no login answer from server\n");
    return false;
    }
  //LDUMP(L_CC_CCCAM2DT,buffer,len,"login answer:");

  if(strcmp(cccamstr,(char *)buffer)!=0) {
    printf("[CCcam] Login failed\n");
    return false;
    }
  //printf("CCcam login OK.\n");
  struct ClientInfo clt;
  memset(&clt,0,sizeof(clt));
  clt.header.cmd=0;
  SETCMDLEN(&clt.header,sizeof(clt));
  strcpy(clt.username,username);
  strcpy(clt.version,versstr);
  strcpy(clt.build,buildstr);
  memcpy(clt.nodeid,nodeid,8);
  clt.wantemus=wantEmus;
  printf("[CCcam] User:%s  Ver:%s<  Bld:%s< Len:%d<  Node:%d< Emu:%d<\n",clt.username,clt.version,clt.build,clt.header.cmdlen,clt.nodeid[0],clt.wantemus);
  //LDUMP(L_CC_CCCAM2DT,&clt,sizeof(clt),"send clientinfo:");
  if(!CryptSend((unsigned char*)&clt,sizeof(clt))) {
    printf("[CCcam] Failed to send Client info\n");
    return false;
    }
  login=true;
  ready=true;
  //printf("Sent client info..\n"); 
  //sleep(1);
  return true;
}


cCardClientCCcam2::~cCardClientCCcam2( void )
{

  login=false; ready=false;
  if (!pthread_cancel(myaction)) printf("Kill thread is not successfull \n");
  if (!pthread_join(myaction,NULL)) printf("Join thread is not successfull \n");
  pendingDCW=maxecmcount=0;
  cmd05mode=CMD05_MODE_UNKNOWN; cmd05off=0;
  cmd0Ccrypt.Reset();
  printf("[CCcam] logout done\n");
  if (fd>=0)
	{
	if (shutdown(fd, 2)<0) perror("[CCcam] socket shutclose");
	if (close(fd)<0) perror("[CCcam] socket close");
	}
}


void cCardClientCCcam2::PacketAnalyzer(const struct CmdHeader *hdr, int length)
{

  int plen=CMDLEN(hdr);

  if(plen<=length) {
    plen-=sizeof(struct CmdHeader);
    switch(hdr->cmd) {
      case 0:
        break;
      case 1:
        {
        struct DcwAnswer *dcw=(struct DcwAnswer *)hdr;
        pthread_mutex_lock( &mtxcw );
	if(pendingDCW>0) pendingDCW--;
        unsigned char tempcw[16], tempcw2[16];
        memcpy(tempcw2,dcw->cw,16);
        pthread_mutex_lock( &mtxshare );
	//if (dbg) printf("got CW, current shareid %08x (pending %d,  maxecmcount=%d)\n",shareid1,pendingDCW,maxecmcount);
        cCCcamCrypt::ScrambleDcw(tempcw2,nodeid,shareid1);
	pthread_mutex_unlock( &mtxshare );
        cmd0Ccrypt.Decrypt(tempcw2,16,tempcw);
	memset(tempcw2,0,16);
        if(pendingDCW==0 && memcmp(tempcw2,tempcw,16))  {
		memcpy(cw,tempcw,16);
        	newcw=true;
		} else if (dbg) printf("pending DCW, skipping bad CW\n");
        decr.Decrypt(tempcw,tempcw,16);
        if(maxecmcount>0 && --maxecmcount<2) {
          printf("disconnecting due to key limit...\n");
          ready=false;
          }
	tamam=true;
	pthread_mutex_unlock( &mtxcw );
        break;
        }
      case 2:       
        break;
      case 4:
        {
        struct DelShare *del=(struct DelShare *)hdr;
	DelS(del);
	break;
        }
      case 5:
        {
        if (dbg) printf("got cmd 05 (payload length=%d)\n",plen);
        unsigned char resp[4+256];
        struct GenericCmd *gen=(struct GenericCmd *)resp;
        memset(resp,0,4);
        gen->header.cmd=5;
        int mode=cmd05mode;
        if(plen==0) mode=CMD05_MODE_LEN0;
        else if(plen==256) {
          if (dbg) printf("cmd 05 mode %d",mode);
          switch(mode) {
            case CMD05_MODE_PLAIN:
              memcpy(gen->payload,((struct GenericCmd *)hdr)->payload,256);
              break;
            case CMD05_MODE_AES:
              {
              cAES aes;
              aes.SetKey(cmd05aes);
              aes.Encrypt(((struct GenericCmd *)hdr)->payload,256,gen->payload);
              break;
              }
            case CMD05_MODE_CC:
              cmd05crypt.Encrypt(((struct GenericCmd *)hdr)->payload,gen->payload,256);
              break;
            case CMD05_MODE_RC4:
              cmd05crypt.DecryptRC4(((struct GenericCmd *)hdr)->payload,gen->payload,256);
              break;
            default:
              mode=CMD05_MODE_UNKNOWN;
              break;
            }
          }
        else mode=CMD05_MODE_UNKNOWN;

        if(mode==CMD05_MODE_UNKNOWN) {
          if(!maxecmcount) maxecmcount=50;
          }
        else maxecmcount=0;

        int l=(mode==CMD05_MODE_UNKNOWN || mode==CMD05_MODE_LEN0) ? 4:4+256;
        if (dbg) printf("sending cmd 05 response (len=%d)\n",l);

  	SETCMDLEN(&gen->header,l);

        
        if(!CryptSend((unsigned char *)gen,l))
          printf("failed to send cmd 05 response\n");
        break;
        }
      case 6:
        if (dbg) printf("Received Server PONG\n");
        break;
      case 7:
        {
        struct AddShare *add=(struct AddShare *)hdr;
	struct ProvInfo *prov=(struct ProvInfo *)(add+1);
        if (add->uphops<=Hop) AddS(add,prov); else if (dbg) printf("Hop is ignored\n");
        break;
        }
      case 8:
        {
        struct ServerInfo *srv=(struct ServerInfo *)hdr;
        if(plen==0x48) {
          printf("[CCcam] server version %s build %s\n",srv->version,srv->build);
          memcpy(cmd0Baes+0,srv->nodeid,8);
          memcpy(cmd0Baes+8,srv->version,8);
          cmd05mode=CMD05_MODE_UNKNOWN;
          }
        else if(plen>=0x00 && plen<=0x0f) {
          cmd05off=plen;
          //if (dbg) printf("cmd 05 offset now %d",cmd05off);
          }
        else if((plen>=0x10 && plen<=0x1f) || (plen>=0x24 && plen<=0x2b)) {
          cmd05crypt.Init(((struct GenericCmd *)hdr)->payload,plen,true);
          cmd05mode=CMD05_MODE_RC4;
          //if (dbg) printf("cmd 05 mode now RC4");
          }
        else if(plen==0x20) {
          memcpy(cmd05aes,((struct GenericCmd *)hdr)->payload+cmd05off,sizeof(cmd05aes));
          cmd05mode=CMD05_MODE_AES;
          //if (dbg) printf("cmd 05 mode now AES (offset=%d)",cmd05off);
          }
        else if(plen==0x21) {
          cmd05crypt.Init(((struct GenericCmd *)hdr)->payload+cmd05off,plen,true);
          cmd05mode=CMD05_MODE_RC4;
          //if (dbg) printf("cmd 05 mode now CC (offset=%d)",cmd05off);
          }
        else if(plen==0x22) {
          cmd05mode=CMD05_MODE_PLAIN;
          //if (dbg) printf("cmd 05 mode now PLAIN");
          }
        else if(plen==0x23) {
          cmd05mode=CMD05_MODE_UNKNOWN;
          //if (dbg) printf("cmd 05 mode now UNKNOWN");
          }
        else if(plen==0x2c) {
          memcpy(cmd05aes,((struct GenericCmd *)hdr)->payload+strlen(password),sizeof(cmd05aes));
          cmd05mode=CMD05_MODE_AES;
          //if (dbg) printf("cmd 05 mode now AES (offset=password=%d)",strlen(password));
          }
        else if(plen==0x2d) {
          memcpy(cmd05aes,((struct GenericCmd *)hdr)->payload+strlen(username),sizeof(cmd05aes));
          cmd05mode=CMD05_MODE_AES;
          //if (dbg) printf("cmd 05 mode now AES (offset=username=%d)",strlen(username));
          }
        else {
          printf("unknown format of serverinfo");
          }
        break;
        }
      case 0xb:
        {
        //if (dbg) printf("got cmd 0b (payload length=%d)",plen);
        unsigned char resp[4+16];
        struct GenericCmd *gen=(struct GenericCmd *)resp;
        memset(resp,0,4);
        gen->header.cmd=0xb;
        cAES aes;
        aes.SetKey(cmd0Baes);
        aes.Encrypt(((struct GenericCmd *)hdr)->payload,16,gen->payload);
        //if (dbg) printf("sending cmd 0b response");

  	SETCMDLEN(&gen->header,sizeof(resp));

        if(!CryptSend((unsigned char *)gen,sizeof(resp))) printf("failed to send cmd 0b response\n");
        break;
        }
      case 0xc:
        {
        //if (dbg) printf("got cmd 0c (payload length=%d)",plen);
        unsigned char *out=AUTOMEM(plen);
        cmd0Ccrypt.Decrypt(((struct GenericCmd *)hdr)->payload,plen,out);
        switch(out[0]) {
          case 0: cmd0Ccrypt.SetMode(CMD0C_MODE_RC6); break;
          case 1: cmd0Ccrypt.SetMode(CMD0C_MODE_RC4); break;
          case 2: cmd0Ccrypt.SetMode(CMD0C_MODE_CC); break;
          case 3: cmd0Ccrypt.SetMode(CMD0C_MODE_AES); break;
          case 4: cmd0Ccrypt.SetMode(CMD0C_MODE_IDEA); break;
          default: cmd0Ccrypt.SetMode(CMD0C_MODE_PLAIN); break;
          }
        cmd0Ccrypt.SetKey(out,plen);
        break;
        }
      case 0xd:
        {
        //if (dbg) printf("got cmd 0d (payload length=%d)",plen);
        unsigned char *out=AUTOMEM(plen);
        cmd0Ccrypt.Decrypt(((struct GenericCmd *)hdr)->payload,plen,out);
        cmd0Ccrypt.SetKey(out,plen);
        break;
        }
      case 0xff:
      case 0xfe:
	pthread_mutex_lock( &mtxcw );
	if(pendingDCW>0) pendingDCW--;
	tamam=true;
	newcw=false;
	//if (dbg) if(hdr->cmd==0xfe) printf("share not found on server (%d pending)\n",pendingDCW);
        //	else printf("server can't decode this ecm, (%d pending)\n",pendingDCW);
	pthread_mutex_unlock( &mtxcw );
        break;
      default:  printf("Invalid header\n");
        break;
      }
    }
  else printf("cmdlen mismatch:%d\n",plen);
    //PRINTF(L_CC_CCCAM2,"cmdlen mismatch: cmdlen=%d length=%d",plen,length);
}



bool cCardClientCCcam2::ProcessECM(cEcmInfo *ecm, unsigned char *data, unsigned char *Cw)
{
  if (!ready) { printf("C: line is down\n"); return false; }
  int sctlen = SCT_LEN (data);
  if (dbg) printf("ECM-> Caid:%04x  Prov:%08x  Sid:%04x  Pid:%04x Sct:%d\n",ecm->caId,ecm->provId,ecm->prgId,ecm->ecm_pid,sctlen);
  
  if(sctlen>=500) {
    printf("ECM data length >=500 not supported by CCcam\n");
    return false;
    }
  int ecm_len=sizeof(struct EcmRequest)+sctlen;
  struct EcmRequest *req=(struct EcmRequest *)AUTOMEM(ecm_len);
  memset(req,0,sizeof(struct EcmRequest));
  memcpy(req+1,data,sctlen);
  req->header.cmd=1;
  pthread_mutex_lock( &mtxshare ); 

  SETCMDLEN(&req->header,ecm_len);

#ifndef BIGE
  BYTE2_BE(&req->caid,ecm->caId);
  BYTE4_BE(&req->provid,ecm->provId);
  BYTE2_BE(&req->sid,ecm->prgId);
  req->datalen=sctlen;
  BYTE4_BE(&req->shareid,shareid1);
#else
 
  BYTE2_LE(&req->caid,ecm->caId);
  BYTE4_LE(&req->provid,ecm->provId);
  BYTE2_LE(&req->sid,ecm->prgId);
  req->datalen=sctlen;
  BYTE4_LE(&req->shareid,shareid1);
  //req->caid=ecm->caId;
  //req->provid=ecm->provId;
  //req->sid=ecm->prgId;
  //req->datalen=sctlen;
  //req->shareid=shareid1;
#endif
  pthread_mutex_unlock( &mtxshare );
  //printf("now try shareid %08x\n",shareid1);
  
  if(pendingDCW>0)  
	{
	printf("WARN: there are pending %d DCW answers. This may cause trouble...\n",pendingDCW);
	ready=false;
	return false;
	}
  pthread_mutex_lock( &mtxcw );
  pendingDCW++;
  tamam=false;
  newcw=false;
  if(!CryptSend((unsigned char *)req,ecm_len)) {
	printf("failed to send ecm request\n");
	pthread_mutex_unlock( &mtxcw );
	return false;
      	}
  int cntr=0;
  while ( !tamam && cntr++<100 && ready)  { pthread_mutex_unlock( &mtxcw ); usleep(50000); pthread_mutex_lock( &mtxcw ); }	//5sec
  if (newcw) {
	memcpy(Cw+0,cw+0,8);
        memcpy(Cw+8,cw+8,8);
	newcw=false;
	pthread_mutex_unlock( &mtxcw );
        return true;
        } 
  if (cntr>=100)
	{
	int i;
	pthread_mutex_lock( &mtxshare );
	for (i=0;i<shrcnt;i++)
		if (ccshare[i].shareid==shareid1) 
			{
			ccshare[i].deleted=true;
			ccshare[i].status=false;
			if (dbg) printf("Timeout....Delshare[%d] -> %08X  is succesfull\n",i,shareid1);
			break;
			}
	if (dbg) if (i==shrcnt) printf("Timeout....Delshare %08X  is not found\n",shareid1);	
	pthread_mutex_unlock( &mtxshare );
	}
  pthread_mutex_unlock( &mtxcw );
  if (dbg) printf("[CCcam] Unable to decode the channel\n");
  return false;
}


void cCardClientCCcam2:: Action(void)
{
  int cnt=0, dec=0;
  unsigned char recvbuff[1024];
  int len=0;
  pthread_detach(pthread_self());
  while (ready) {
    len=sizeof(recvbuff)-cnt;
    if(len==0) {
      	printf("internal: cccam2 read buffer overflow\n");
      	ready=false;
      	break;
      	}
    len=RecvMsg(recvbuff+cnt,len,-1);
    //if (!len) printf("No data received.\n");
    if (!ready) break;
    if(len>0) {
      	//if (dbg) printf("net read: len=%d cnt=%d dec=%d\n",len,cnt+len,dec);
      	cnt+=len;
      	}
    // We cannot decrypt the whole buffer because it might contain an DCW
    // cmd followed by others. But the DCW has an additional Decrypt() during
    // processing, so the crypt state would be wrong for the rest of the buffer.
    int proc=0;
    if (len>0)
    while(proc+(int)sizeof(struct CmdHeader)<=cnt) {
      	// First decrypt the cmd header only!
     	 int a;
      	if((a=proc+sizeof(struct CmdHeader)-dec)>0) {
        	decr.Decrypt(recvbuff+dec,recvbuff+dec,a);
        	dec+=a;
        	//if (dbg) printf("hdr decrypt: cnt=%d proc=%d dec=%d\n",cnt,proc,dec);
        	} //else if (dbg) printf("hdr decrypt not done: cnt=%d proc=%d dec=%d\n",cnt,proc,dec);
      	struct CmdHeader *hdr=(struct CmdHeader *)(recvbuff+proc);

      	int l=CMDLEN(hdr);

      	if(l>(int)sizeof(recvbuff)) {
       		printf("internal: cccam2 cmd length exceed buffer size : %d\n",l);
        	ready=false;
       	 	break;
        	}
      	if(proc+l>cnt) {
        	//if (dbg) printf("cmd incomplete: proc+l=%d cnt=%d dec=%d\n",proc+l,cnt,dec);
        	break;
        	}
      	// Now decrypt payload for this cmd only!
      	if((a=proc+l-dec)>0) {
        	decr.Decrypt(recvbuff+dec,recvbuff+dec,a);
        	dec+=a;
        	//if (dbg) printf("payload decrypt: cnt=%d proc=%d dec=%d\n",cnt,proc,dec);
        	}
      	PacketAnalyzer(hdr,l);
      	proc+=l;
      	}
    if(proc) {
      	cnt-=proc; dec-=proc;
      	memmove(recvbuff,recvbuff+proc,cnt);
      	}
    if(len==0) {
      	static const struct CmdHeader ping = { 0,6,0 };
     	if(!CryptSend((unsigned char *)&ping,sizeof(ping)))
        	printf("failed to send server PING\n");
      	}
    usleep(10);
    }
  if (dbg) printf("Server disconnected\n");
  ready=false;
  pthread_exit(NULL);
}

int cCardClientCCcam2::CryptRecv(unsigned char *data, int len, int to)
{
  pthread_mutex_lock( &mtxrecv );
  int r=RecvMsg(data,len,to);
  if(r>0) decr.Decrypt(data,data,r);
  pthread_mutex_unlock( &mtxrecv );
  return r;
}

bool cCardClientCCcam2::CryptSend(const unsigned char *data, int len)
{
  bool retval;
  pthread_mutex_lock( &mtxsend );
  unsigned char *buff=AUTOMEM(len);
  encr.Encrypt(data,buff,len);
  //lastsend.Set(PING_TIME);
  retval= SendMsg(buff,len);
  pthread_mutex_unlock( &mtxsend );
  return retval;
}

bool cCardClientCCcam2::SendMsg(unsigned char *buffer1, int length)
{
	//write with time-out
	struct pollfd pfd;
	int write_result;
	
	pfd.fd = fd;
	pfd.events = POLLOUT | POLLERR;
	pfd.revents = 0;
	
	if(poll(&pfd, 1, network_timeout) != 1) return false;
	
	if(pfd.revents & POLLOUT)
	{
		if( (write_result = write(fd, buffer1, length)) <= 0 ) return false;
		return true;
	}
	else
		return false;
}

int cCardClientCCcam2::RecvMsg(unsigned char *buffer1, int length, int override_timeout)
{
	//read with time-out
	struct pollfd pfd;
	int read_result;
	
	pfd.fd = fd;
	pfd.events = POLLIN | POLLERR;
	pfd.revents = 0;
	
	if( override_timeout < 0 ) override_timeout = network_timeout;
	
	if(poll(&pfd, 1, override_timeout) != 1) return 0;
	
	if(pfd.revents & POLLIN)
	{
		if( (read_result = read(fd, buffer1, length)) <= 0 ) { ready = false; return 0; }
		return read_result;
	}
	else
		return 0;
}

void cCardClientCCcam2::AddS(AddShare *share1, ProvInfo *prov1)
{
if (shrcnt>490) return;
pthread_mutex_lock( &mtxshare );
#ifndef BIGE
int caid=UINT16_BE(&share1->caid);
int shareidx=UINT32_BE(&share1->shareid);
#else
int caid=UINT16_LE(&share1->caid);
int shareidx=UINT32_LE(&share1->shareid);
#endif
int i;
for (i=0;i<shrcnt;i++)
	if (ccshare[i].deleted) break;
if (i==shrcnt) shrcnt++;

ccshare[i].shareid=shareidx;
ccshare[i].caid=caid;
ccshare[i].deleted=false;
ccshare[i].status=true;
ccshare[i].uphops=share1->uphops;
ccshare[i].maxdown=share1->maxdown;
ccshare[i].provcnt=prov1->count;
if (dbg)  
printf("ADDSHARE[%d]-> shareid: %08X  hops:%d  maxdown:%d  Caid:%04X  ProvCount:%d\n",i,shareidx,ccshare[i].uphops,ccshare[i].maxdown,caid,ccshare[i].provcnt );
for(int j=0; j<prov1->count; j++) 
		{
		//if (dbg) printf("\tPROV / SA  %06x/%08x\n",UINT32_BE(prov1->prov[j].provid-1)&0xFFFFFF,UINT32_BE(prov1->prov[j].sa));
		#ifndef BIGE
		ccshare[i].provid[j]=UINT32_BE(prov1->prov[j].provid-1)&0xFFFFFF;
		#else
		ccshare[i].provid[j]=UINT32_LE(prov1->prov[j].provid-1)&0xFFFFFF;
		#endif
		if (dbg) printf("----- Prov %d : %08x \n",j,ccshare[i].provid[j]);
		} 
pthread_mutex_unlock( &mtxshare );
}

void cCardClientCCcam2::DelS(DelShare *oldshare)
{
int i;
pthread_mutex_lock( &mtxshare );
#ifndef BIGE
int shareidx=UINT32_BE(&oldshare->shareid);
#else
int shareidx=UINT32_LE(&oldshare->shareid);
#endif
//printf("Del share %08x  \n",shareid);
for (i=0;i<shrcnt;i++)
	if (ccshare[i].shareid==shareidx) 
		{
		ccshare[i].deleted=true;
		ccshare[i].status=false;
		if (dbg) printf("Delshare[%d] -> %08X  is succesfull\n",i,shareidx);
		break;
		}
if (dbg) if (i==shrcnt) printf("Delshare %08X  is not found\n",shareidx);
pthread_mutex_unlock( &mtxshare );
}

/////
int cCardClientCCcam2::HasECM(cEcmInfo *ecm, int istart)
{
int i,j;
if (!ready) { printf("C: line is down\n"); return -1; }

if (istart<0) { istart=0; }

pthread_mutex_lock( &mtxshare );
for (i=istart;i<shrcnt;i++) 
   if ( (!ccshare[i].deleted) && (ccshare[i].status) )
	{
	if (ccshare[i].provcnt==0) 
		{
		if (ccshare[i].caid==ecm->caId)
			{
			shareid1=ccshare[i].shareid;
			if (dbg) printf("Trying Share id : %08x  (%d/%d)\n",shareid1,i,shrcnt);
			pthread_mutex_unlock( &mtxshare );
			return i+1;
			}
		}
	else for (j=0;j<ccshare[i].provcnt;j++)  
		if ( ccshare[i].caid==ecm->caId && ( ccshare[i].provid[j]==ecm->provId  || (ecm->caId>>8==0x0d && ccshare[i].provid[j]==0) ) )
			{
			shareid1=ccshare[i].shareid;
			if (dbg) printf("Trying Share id : %08x  (%d/%d)\n",shareid1,i,shrcnt);
			pthread_mutex_unlock( &mtxshare );
			return i+1;
			}
	}
pthread_mutex_unlock( &mtxshare );
return -1;
}
